#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <winsock2.h>
#include <sys/types.h>
 
static LPSTR PrintError(int ErrorCode);

int main(int argc, char *argv[])
{
    // Enable WinSock2
    WORD wVersionRequested;
    wVersionRequested = MAKEWORD( 2, 2 );

    WSADATA wsaData;
    int rc;
    rc = WSAStartup( wVersionRequested, &wsaData );
    if (rc != 0)
    {
        fprintf(stderr, "Cannot find an usable WinSock2 dll");
        exit(1);
    }

    // Check the command line
    if(argc != 2)
    {
        fprintf(stderr, "Usage: %s hostname\n", argv[0]);
        exit(1);
    }
 
    // Get the host info
    struct hostent *hostent;
    char *host = argv[1];
    if((hostent = gethostbyname(host)) == NULL)
    {
        fprintf(stderr, "gethostbyname() failed with error %d: %s\n",
                WSAGetLastError(), PrintError(WSAGetLastError()));
        exit(1);
    }
 
    // Print to output
    printf("Hostname: %s\n", hostent->h_name);
    printf("IP Address: %s\n", inet_ntoa(*((struct in_addr *)hostent->h_addr)));
 
    return 0;
}

LPSTR PrintError(int ErrorCode)
{
    static char Message[1024];

    // If this program was multithreaded, we'd want to use
    // FORMAT_MESSAGE_ALLOCATE_BUFFER instead of a static buffer here.
    // (And of course, free the buffer when we were done with it)

    FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS |
                  FORMAT_MESSAGE_MAX_WIDTH_MASK, NULL, ErrorCode,
                  MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
                  (LPWSTR) Message, 1024, NULL);
    return Message;
}
